  PROGRAM
!
! Author:   Brian Staff
! Requires: ADO - installed with Office 2000 & MDAC 2.1/2.5/2.6 - also at www.microsoft.com/data/
!           OLETCL class code, written by Jim Kane, available at www.clarionmag.com
!                  search for oletcl and download the source
!
_abcdllmode_  EQUATE(0)
_abclinkmode_ EQUATE(1)
  MAP
  END
INCLUDE('oletcl.inc') !available from www.clarionmag.com

!---------Following EQUATEs taken from ADOVBS.INC - 'ADO constants include file for VBScript'-----\
!---- CursorLocationEnum Values ----
adUseServer           EQUATE(2)
adUseClient           EQUATE(3)
!---- CursorTypeEnum Values ----
adOpenForwardOnly     EQUATE(0)
adOpenKeyset          EQUATE(1)
adOpenDynamic         EQUATE(2)
adOpenStatic          EQUATE(3)

!---- LockTypeEnum Values ----
adLockReadOnly        EQUATE(1)
adLockPessimistic     EQUATE(2)
adLockOptimistic      EQUATE(3)
adLockBatchOptimistic EQUATE(4)

!---- CommandTypeEnum Values ----
adCmdUnknown          EQUATE(0008h)
adCmdText             EQUATE(0001h)
adCmdTable            EQUATE(0002h)
adCmdStoredProc       EQUATE(0004h)
!-------------------------------------------------------------------------------------------------/
max                   EQUATE(16)
oFileX                &oleTClType     !dim RecordSetObject
strConnect            CSTRING(100)
sql                   CSTRING(500)
ThisFileName          CSTRING(20)
MyEOF                 BYTE
cols                  CSTRING(4)
title                 CSTRING(60)
j                     LONG
colf                  CSTRING(20)
qs                    QUEUE
g                       GROUP
col1                      LIKE(colf)
col2                      LIKE(colf)
col3                      LIKE(colf)
col4                      LIKE(colf)
col5                      LIKE(colf)
col6                      LIKE(colf)
col7                      LIKE(colf)
col8                      LIKE(colf)
col9                      LIKE(colf)
col10                     LIKE(colf)
col11                     LIKE(colf)
col12                     LIKE(colf)
col13                     LIKE(colf)
col14                     LIKE(colf)
col15                     LIKE(colf)
col16                     LIKE(colf)
                        END
                      END
colx                  LIKE(colf),DIM(max),OVER(qs.g)
s1                    STRING(30)

MyWindow WINDOW('Caption'),AT(,,382,160),FONT('Arial',8,,FONT:regular,CHARSET:ANSI),IMM,GRAY,MAX,RESIZE
       PROMPT(''),AT(1,1),USE(?p1),HIDE
       LIST,AT(10,6,362,146),USE(?List),HVSCROLL,FROM(qs)
     END

 CODE
    !n.b. change these 2 lines accordingly
    ! for your file name and directory
    ! filename is actually CUST.TPS
    ThisFileName  = 'cust'
    !Use DRIVER={{Topspeed ODBC Driver} for the
    ! real ODBC driver
    strConnect = 'DRIVER={{Topspeed Developer version};DBQ=C:\data\'


    !The above ODBC connection string uses a
    ! DSN-less connection
    !if the Developer Topspeed ODBC driver is
    ! used, the user needs to click on the
    ! splash screen
    !n.b. parameters required above are different
    ! for each ODBC driver - if in doubt, look
    ! in windows registry

    !instantiate Jim Kanes class wrapper
    ! for OLE controls
    oFileX       &= NEW oleTClType

    !---------------------------------------------\
    ! use GetProp when a result is expected for
    !  properties & methods
    ! use CallMethod when NO result is expected
    !
    ! n.b. using GetProp nested inside another
    ! Clarion statement does not seem to work
    ! always store the GetProp result in a local
    ! variable first
    !
    ! "Fields" is a collection (read queue)
    ! of properties for each column
    !---------------------------------------------/

    DO PrimeRecordSet
    OPEN(Mywindow)
    !populate LIST control with data
    DO GetData 

    ACCEPT
      CASE EVENT()
      OF   EVENT:Sized
           ?List{PROP:Width}  = 0{PROP:Width}  - 20
           ?List{PROP:Height} = 0{PROP:Height} - 14
      END
    END

    FREE(qs)
    CLOSE(MyWindow)
    RETURN

PrimeRecordSet ROUTINE
    oFileX.init('ADODB.RecordSet',0) !1==debugmode
    !use client cursors - gives recordcount
    ! plus appears to be much safer in multi-user
    oFileX.SetProp('CursorLocation',adUseClient) 
    sql  = 'SELECT * FROM ' & ThisFileName
    oFileX.CallMethod('Open("'&sql&'", "'&strConnect&'", "'&adOpenForwardOnly&'", "'&adLockReadOnly&'", "'&adCmdText&'")')
    Cols = oFileX.GetProp('Fields.Count')
    title  = 'Browse ' & CLIP(ThisFileName) |
      & ' ' & CLIP(Cols) & ' columns' |
      & CHOOSE(CLIP(Cols)>max,' (' |
      & max & ' shown)','')

GetData ROUTINE
    SETCURSOR(CURSOR:Wait)
    !applying column width is done in pixels
    0{PROP:Pixels} = '1'
    !loop thru the fields & apply header
    ! text and column format strings
    LOOP j = 1 TO CLIP(Cols)        
      s1  = oFileX.GetProp('Fields('& j-1 &').Name')
      !get exact width of fieldname to apply column width
      ?p1{PROP:Text}= CLIP(s1)
      !add 4 for rh/lh offset
      ?List{PROPList:Format,j} = (?p1{PROP:Width} + 4) |
        & 'L(2)M|~Hdr~(2)@s30@' 
      ?List{PROPList:Header,j} = s1
      !do max columns only
      IF j >= max THEN BREAK.             
    END
    0{PROP:Pixels} = ''
    FREE(qs)
    i# = oFileX.GetProp('RecordCount')
    0{PROP:Text} = CLIP(title) & ' - records: ' & i#
    !get all rows from table - initially
    ! positioned on the the first row of the recordset
    LOOP 
         MyEOF = oFileX.GetProp('EOF')
         IF MyEOF <> 0 THEN BREAK.
         !fill each column with data for this row
         LOOP j = 1 TO CLIP(Cols) 
              colx[j] = oFileX.GetProp('Fields('& j-1 & ').Value')
              IF j >= max THEN BREAK.
         END
         !Here's now to do field retrieval using explicit
         ! field names - modify FieldNameN accordingly
         OMIT('***')
             v1" = oFileX.GetProp('Fields("FieldName1").Value') 
             v2" = oFileX.GetProp('Fields("FieldName2").Value')
         !***
         ADD(qs)
         !get the next row of the recordset
         oFileX.CallMethod('MoveNext()') 
    END
    !close the recordset
    oFileX.CallMethod('Close()') 
    oFileX.Kill()
    DISPOSE(oFileX)
    SETCURSOR()

