  program

  map
CreateDupFile procedure()
TestFileForDup procedure(FILE TestFile)
  end

  include('gjsDup.inc'), once

FirstNames string('Gordon    ' & |
                  'Brian     ' & |
                  'Dermot    ' & |
                  'Peter     ' & |
                  'Paul      ' & |
                  'Steve     ')

fName string(10), dim(6), over(FirstNames)

LastNames  string('Smith     ' & |
                  'Blessed   ' & |
                  'Lynch     ' & |
                  'McNamee   ' & |
                  'Terrett   ' & |
                  'Griffin   ')

lName string(10), dim(6), over(LastNames)

SampleFile               FILE,DRIVER('TOPSPEED'),PRE(TST),CREATE,THREAD,NAME('TestFile.TPS')
N KEY(TST:lName,TST:Fname,TST:ID),NOCASE,OPT !Name Key
Record                   RECORD
Fname                      STRING(20)
lName                      STRING(20)
ID                         LONG
                         END
                       END

  code
  CreateDupFile()
  TestFileForDup(SampleFile)

TestFileForDup procedure(FILE TestFile)

cFind FindDupClass

  code
  cFind.Init(TestFile)
  cFind.BuildKeys()
  cFind.FindDup()
  cFind.Display()
  cFind.Kill()

CreateDupFile procedure()

  code
  setcursor(CURSOR:Wait)
  create(SampleFile); assert(~errorcode())
  open(SampleFile); assert(~errorcode())
  logout(1, SampleFile); assert(~errorcode())   !For speed
  loop 100 times
    TST:FName = fName[random(1,6)]
    TST:LName = lName[random(1,6)]
    TST:ID = random(1,20)                       !Lets not create too many duplicate.
    append(SampleFile); assert(~errorcode())
  end
  commit(); assert(~errorcode())
  close(SampleFile); assert(~errorcode())
  setcursor()
